import greenfoot.*;

public class Car extends Vehicle
{
    private int _numHits;

    public Car() 
    {
        _numHits = 0;
    }
    
    public void act()
    {
        /** 
         * The following line of code turns the Car by 1 degree to the left each time
         * act is called. 
         */
        //turn(-1);
        /** 
         * If we find ourselves at the edge of the world, turn some number of degrees.
         * Changing the number of degrees changes the behavior.
         */
        if(atWorldEdge())
        {
            turn(25);
        }
        
        /**
         * We want to perform an action 20% of the time
         */
        if( Greenfoot.getRandomNumber(100) < 20 )
        {
            //Turn 45 degrees 20% of the time
            //turn(45);
            
            //Turn -32 degrees 20% of the time (negative is to the left)
            //turn(-32);
            
            //Move 20% of the time
            //move();
            
            //Turn a random number of degrees between -90 and 90
            //turn(Greenfoot.getRandomNumber(181)-90);
 
            //Select a random number 0 or 1 and decide if negative based on that
            //This part is not correct yet.
            if(Greenfoot.getRandomNumber(2) == 0) {
                turn(Greenfoot.getRandomNumber(90) * -1);
            }
            else {
                turn(Greenfoot.getRandomNumber(90));
            }
        }
        
        /**
         * React to the r key (ignores case).  Turn to the right if pressed.
         */          
        if(Greenfoot.isKeyDown("r"))
        {
            turn(32);
        }
        
        /**
         * React to the left arrow.  Turn to the left if pressed.
         */

        checkForBarrels();

        /**
         * No matter what else happens, the car always moves.
         */
        move();
    }
    
    private void checkForBarrels() 
    {
        if(canSee(Barrel.class))//hit barrel
        {
            //note that we've hit a barrel
            _numHits = _numHits + 1;
            if(_numHits >= 20) //we've hit too many
            {
                Greenfoot.stop(); //stop scenario
            }
            
            if(_numHits % 2 == 0)
            {
                setImage("tux.png");
            }
            else 
            {
                setImage("car.png");
            }    
            
            turn(180);
        }
    }
}
